//+------------------------------------------------------------------+
//|                                                         SQDVO.mq4|
//|                            Copyright © @2021 StrategyQuant s.r.o.|
//|                                     http://www.strategyquant.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright © @2021 StrategyQuant s.r.o."
#property  link      "http://www.strategyquant.com"

//---- indicator settings
#property  indicator_separate_window;
#property  indicator_buffers 1
#property  indicator_color1  Red
#property  indicator_width1  1

//----

extern int SMAPeriod=10;
extern int PercentRankPeriod=120;

//---- buffers
double IndiBuffer[];
double SMABuffer[];


//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {

   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,EMPTY_VALUE);
   SetIndexDrawBegin(0,MathMax(SMAPeriod,PercentRankPeriod));
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   SetIndexBuffer(0,IndiBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,SMABuffer,INDICATOR_CALCULATIONS);
   IndicatorShortName("SqDVO("+SMAPeriod+","+PercentRankPeriod+")");

   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double sma,dvo;
   int i, limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit; i>=0; i--)
     {
      int count =0;
      double sum =0;

      for(int s = 0; s< SMAPeriod; s++){
      
        if((High[i+s]+Low[i+s])!=0)sum = sum +(Close[i+s]/((High[i+s]+Low[i+s])/2));
        
      }
      
      SMABuffer[i] = sum/SMAPeriod;
     
      int pRank =0;
      for(int p = 1; p<= PercentRankPeriod; p++){
      
         if(NormalizeDouble(SMABuffer[i],6)>NormalizeDouble(SMABuffer[i+p],6)){

            pRank = pRank +1;
         }
         
        dvo = 100*pRank/(double)PercentRankPeriod;

       }

      IndiBuffer[i] =dvo;

     }
    
   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
